#ifndef _OPT_CONFIG_H_
#define _OPT_CONFIG_H_

#include <string>
#include <utility>
#include <vector>

class OptConfig {
 public:
  
  OptConfig();

  OptConfig(const OptConfig &config);

  ~OptConfig();

  OptConfig &operator=(const OptConfig &config);

  void SetProperty(const std::string &property);

  void SetProperty(const std::string &property,
		   int value);

  void SetProperty(const std::string &property,
		   double value);
  
  const std::vector<std::string> &GetBinaryProperties() const;

  const std::vector<std::pair<std::string,int> > &GetIntProperties() const;

  const std::vector<std::pair<std::string,double> > &GetDoubleProperties()
    const;
  
 private:
  struct M_Data;

  M_Data *m_data;
};

#endif // #ifndef _OPT_CONFIG_H_
