#ifndef _OPT_SOLVER_H_
#define _OPT_SOLVER_H_

class OptConfig;
class OptProblem;

// abstract base class for optimization solvers
class OptSolver {
 public:

  // returns true if the given problem was solved, false otherwise
  // the solution results are in OptProblem
  virtual bool Solve(const OptConfig &config,
		     OptProblem *problem,
		     double *x,
		     double *f) = 0;
  
};

#endif // _OPT_SOLVER_H_
